VampPluginSDK 2.1

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Protected Member Functions | Protected Attributes
Vamp::Plugin Class Reference

Vamp::Plugin is a base class for plugin instance classes that provide feature extraction from audio or related data. More...

`#include <vamp-sdk/Plugin.h>`

Inheritance diagram for Vamp::Plugin:
[legend]

List of all members.

## Classes
struct | Feature
struct | OutputDescriptor
## Public Types
enum | InputDomain { TimeDomain, FrequencyDomain }
typedef std::vector < OutputDescriptor > | OutputList
typedef std::vector< Feature > | FeatureList
typedef std::map< int, FeatureList > | FeatureSet
typedef std::vector < ParameterDescriptor > | ParameterList
typedef std::vector< std::string > | ProgramList
## Public Member Functions
virtual | ~Plugin ()
virtual bool | initialise (size_t inputChannels, size_t stepSize, size_t blockSize)=0
| Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).
virtual void | reset ()=0
| Reset the plugin after use, to prepare it for another clean run.
virtual InputDomain | getInputDomain () const =0
| Get the plugin's required input domain.
virtual size_t | getPreferredBlockSize () const
| Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).
virtual size_t | getPreferredStepSize () const
| Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.
virtual size_t | getMinChannelCount () const
| Get the minimum supported number of input channels.
virtual size_t | getMaxChannelCount () const
| Get the maximum supported number of input channels.
virtual OutputList | getOutputDescriptors () const =0
| Get the outputs of this plugin.
virtual FeatureSet | process (const float *const *inputBuffers, RealTime timestamp)=0
| Process a single block of input data.
virtual FeatureSet | getRemainingFeatures ()=0
| After all blocks have been processed, calculate and return any remaining features derived from the complete input.
virtual std::string | getType () const
| Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.
virtual unsigned int | getVampApiVersion () const
| Get the Vamp API compatibility level of the plugin.
virtual std::string | getIdentifier () const =0
| Get the computer-usable name of the plugin.
virtual std::string | getName () const =0
| Get a human-readable name or title of the plugin.
virtual std::string | getDescription () const =0
| Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".
virtual std::string | getMaker () const =0
| Get the name of the author or vendor of the plugin in human-readable form.
virtual std::string | getCopyright () const =0
| Get the copyright statement or licensing summary for the plugin.
virtual int | getPluginVersion () const =0
| Get the version number of the plugin.
virtual ParameterList | getParameterDescriptors () const
| Get the controllable parameters of this plugin.
virtual float | getParameter (std::string) const
| Get the value of a named parameter.
virtual void | setParameter (std::string, float)
| Set a named parameter.
virtual ProgramList | getPrograms () const
| Get the program settings available in this plugin.
virtual std::string | getCurrentProgram () const
| Get the current program.
virtual void | selectProgram (std::string)
| Select a program.
## Protected Member Functions
| Plugin (float inputSampleRate)
## Protected Attributes
float | m_inputSampleRate

## Detailed Description

Vamp::Plugin is a base class for plugin instance classes that provide feature extraction from audio or related data.

In most cases, the input will be audio and the output will be a stream of derived data at a lower sampling resolution than the input.

Note that this class inherits several abstract methods from PluginBase. These must be implemented by the subclass.

PLUGIN LIFECYCLE

Feature extraction plugins are managed differently from real-time plugins (such as VST effects). The main difference is that the parameters for a feature extraction plugin are configured before the plugin is used, and do not change during use.

1. Host constructs the plugin, passing it the input sample rate. The plugin may do basic initialisation, but should not do anything computationally expensive at this point. You must make sure your plugin is cheap to construct, otherwise you'll seriously affect the startup performance of almost all hosts. If you have serious initialisation to do, the proper place is in initialise() (step 5).

2. Host may query the plugin's available outputs.

3. Host queries programs and parameter descriptors, and may set some or all of them. Parameters that are not explicitly set should take their default values as specified in the parameter descriptor. When a program is set, the parameter values may change and the host will re-query them to check.

4. Host queries the preferred step size, block size and number of channels. These may all vary depending on the parameter values. (Note however that you cannot make the number of distinct outputs dependent on parameter values.)

5. Plugin is properly initialised with a call to initialise. This fixes the step size, block size, and number of channels, as well as all of the parameter and program settings. If the values passed in to initialise do not match the plugin's advertised preferred values from step 4, the plugin may refuse to initialise and return false (although if possible it should accept the new values). Any computationally expensive setup code should take place here.

6. Host finally checks the number of values, resolution, extents etc per output (which may vary depending on the number of channels, step size and block size as well as the parameter values).

7. Host will repeatedly call the process method to pass in blocks of input data. This method may return features extracted from that data (if the plugin is causal).

8. Host will call getRemainingFeatures exactly once, after all the input data has been processed. This may return any non-causal or leftover features.

9. At any point after initialise was called, the host may optionally call the reset method and restart processing. (This does not mean it can change the parameters, which are fixed from initialise until destruction.)

A plugin does not need to handle the case where setParameter or selectProgram is called after initialise has been called. It's the host's responsibility not to do that. Similarly, the plugin may safely assume that initialise is called no more than once.

Definition at line 124 of file vamp-sdk/Plugin.h.

## Member Typedef Documentation

typedef std::vector<OutputDescriptor> Vamp::Plugin::OutputList

Definition at line 327 of file vamp-sdk/Plugin.h.

typedef std::vector<Feature> Vamp::Plugin::FeatureList

Definition at line 385 of file vamp-sdk/Plugin.h.

typedef std::map<int, FeatureList> Vamp::Plugin::FeatureSet

Definition at line 387 of file vamp-sdk/Plugin.h.

typedef std::vector<ParameterDescriptor> Vamp::PluginBase::ParameterList`[inherited]`

Definition at line 203 of file vamp-sdk/PluginBase.h.

typedef std::vector<std::string> Vamp::PluginBase::ProgramList`[inherited]`

Definition at line 225 of file vamp-sdk/PluginBase.h.

## Member Enumeration Documentation

enum Vamp::Plugin::InputDomain

Enumerator:

  TimeDomain |
  FrequencyDomain |

Definition at line 152 of file vamp-sdk/Plugin.h.

## Constructor & Destructor Documentation

virtual Vamp::Plugin::~Plugin | ( |  | ) | `[inline, virtual]`

Definition at line 127 of file vamp-sdk/Plugin.h.

Vamp::Plugin::Plugin | ( | float | inputSampleRate | ) | `[inline, protected]`

Definition at line 433 of file vamp-sdk/Plugin.h.

## Member Function Documentation

virtual bool Vamp::Plugin::initialise | ( | size_t | inputChannels,
|  | size_t | stepSize,
|  | size_t | blockSize
| ) |  | `[pure virtual]`

Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).

The input sample rate should have been already specified at construction time.

Return true for successful initialisation, false if the number of input channels, step size and/or block size cannot be supported.

Implemented in Vamp::HostExt::PluginChannelAdapter, Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginInputDomainAdapter, Vamp::HostExt::PluginSummarisingAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by runPlugin().

virtual void Vamp::Plugin::reset | ( |  | ) | `[pure virtual]`

Reset the plugin after use, to prepare it for another clean run.

Not called for the first initialisation (i.e. initialise must also do a reset).

Implemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginInputDomainAdapter, Vamp::HostExt::PluginSummarisingAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

virtual InputDomain Vamp::Plugin::getInputDomain | ( |  | ) | const`[pure virtual]`

Get the plugin's required input domain.

If this is TimeDomain, the samples provided to the process() function (below) will be in the time domain, as for a traditional audio processing plugin.

If this is FrequencyDomain, the host will carry out a windowed FFT of size equal to the negotiated block size on the data before passing the frequency bin data in to process(). The input data for the FFT will be rotated so as to place the origin in the centre of the block. The plugin does not get to choose the window type -- the host will either let the user do so, or will use a Hanning window.

Implemented in Vamp::HostExt::PluginInputDomainAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins(), and runPlugin().

virtual size_t Vamp::Plugin::getPreferredBlockSize | ( |  | ) | const`[inline, virtual]`

Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).

This should be called before initialise().

A plugin that can handle any block size may return 0. The final block size will be set in the initialise() call.

Reimplemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginInputDomainAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 179 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), and runPlugin().

virtual size_t Vamp::Plugin::getPreferredStepSize | ( |  | ) | const`[inline, virtual]`

Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.

This should be called before initialise().

A plugin may return 0 if it has no particular interest in the step size. In this case, the host should make the step size equal to the block size if the plugin is accepting input in the time domain. If the plugin is accepting input in the frequency domain, the host may use any step size. The final step size will be set in the initialise() call.

Reimplemented in Vamp::HostExt::PluginInputDomainAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 194 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), and runPlugin().

virtual size_t Vamp::Plugin::getMinChannelCount | ( |  | ) | const`[inline, virtual]`

Get the minimum supported number of input channels.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 199 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), FixedTempoEstimator::initialise(), PercussionOnsetDetector::initialise(), AmplitudeFollower::initialise(), SpectralCentroid::initialise(), ZeroCrossing::initialise(), PowerSpectrum::initialise(), and runPlugin().

virtual size_t Vamp::Plugin::getMaxChannelCount | ( |  | ) | const`[inline, virtual]`

Get the maximum supported number of input channels.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 204 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), FixedTempoEstimator::initialise(), PercussionOnsetDetector::initialise(), AmplitudeFollower::initialise(), SpectralCentroid::initialise(), ZeroCrossing::initialise(), PowerSpectrum::initialise(), and runPlugin().

virtual OutputList Vamp::Plugin::getOutputDescriptors | ( |  | ) | const`[pure virtual]`

Get the outputs of this plugin.

An output's index in this list is used as its numeric index when looking it up in the FeatureSet returned from the process() call.

Implemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, PercussionOnsetDetector, PowerSpectrum, AmplitudeFollower, SpectralCentroid, and ZeroCrossing.

Referenced by enumeratePlugins(), and runPlugin().

virtual FeatureSet Vamp::Plugin::process | ( | const float *const * | inputBuffers,
|  | RealTime | timestamp
| ) |  | `[pure virtual]`

Process a single block of input data.

If the plugin's inputDomain is TimeDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize consecutive audio samples (the host will zero-pad as necessary). The timestamp in this case will be the real time in seconds of the start of the supplied block of samples.

If the plugin's inputDomain is FrequencyDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize/2+1 consecutive pairs of real and imaginary component floats corresponding to bins 0..(blockSize/2) of the FFT output. That is, bin 0 (the first pair of floats) contains the DC output, up to bin blockSize/2 which contains the Nyquist-frequency output. There will therefore be blockSize+2 floats per channel in total. The timestamp will be the real time in seconds of the centre of the FFT input window (i.e. the very first block passed to process might contain the FFT of half a block of zero samples and the first half-block of the actual data, with a timestamp of zero).

Return any features that have become available after this process call. (These do not necessarily have to fall within the process block, except for OneSamplePerStep outputs.)

Implemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginChannelAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginInputDomainAdapter, Vamp::HostExt::PluginSummarisingAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, PercussionOnsetDetector, AmplitudeFollower, PowerSpectrum, SpectralCentroid, and ZeroCrossing.

Referenced by runPlugin().

virtual FeatureSet Vamp::Plugin::getRemainingFeatures | ( |  | ) | `[pure virtual]`

After all blocks have been processed, calculate and return any remaining features derived from the complete input.

Implemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginSummarisingAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, PercussionOnsetDetector, AmplitudeFollower, PowerSpectrum, SpectralCentroid, and ZeroCrossing.

Referenced by runPlugin().

virtual std::string Vamp::Plugin::getType | ( |  | ) | const`[inline, virtual]`

Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.

Do not reimplement this function in your subclass.

Implements Vamp::PluginBase.

Definition at line 430 of file vamp-sdk/Plugin.h.

virtual unsigned int Vamp::PluginBase::getVampApiVersion | ( |  | ) | const`[inline, virtual, inherited]`

Get the Vamp API compatibility level of the plugin.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 72 of file vamp-sdk/PluginBase.h.

Referenced by enumeratePlugins().

virtual std::string Vamp::PluginBase::getIdentifier | ( |  | ) | const`[pure virtual, inherited]`

Get the computer-usable name of the plugin.

This should be reasonably short and contain no whitespace or punctuation characters. It may only contain the characters [a-zA-Z0-9_-]. This is the authoritative way for a program to identify a plugin within a given library.

This text may be visible to the user, but it should not be the main text used to identify a plugin to the user (that will be the name, below).

Example: "zero_crossings"

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins(), and runPlugin().

virtual std::string Vamp::PluginBase::getName | ( |  | ) | const`[pure virtual, inherited]`

Get a human-readable name or title of the plugin.

This should be brief and self-contained, as it may be used to identify the plugin to the user in isolation (i.e. without also showing the plugin's "identifier").

Example: "Zero Crossings"

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins(), and printPluginCategoryList().

virtual std::string Vamp::PluginBase::getDescription | ( |  | ) | const`[pure virtual, inherited]`

Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".

May be empty if the name has said it all already.

Example: "Detect and count zero crossing points"

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins(), and printPluginCategoryList().

virtual std::string Vamp::PluginBase::getMaker | ( |  | ) | const`[pure virtual, inherited]`

Get the name of the author or vendor of the plugin in human-readable form.

This should be a short identifying text, as it may be used to label plugins from the same source in a menu or similar.

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins(), and printPluginCategoryList().

virtual std::string Vamp::PluginBase::getCopyright | ( |  | ) | const`[pure virtual, inherited]`

Get the copyright statement or licensing summary for the plugin.

This can be an informative text, without the same presentation constraints as mentioned for getMaker above.

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins().

virtual int Vamp::PluginBase::getPluginVersion | ( |  | ) | const`[pure virtual, inherited]`

Get the version number of the plugin.

Implemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, PowerSpectrum, AmplitudeFollower, SpectralCentroid, ZeroCrossing, FixedTempoEstimator, and PercussionOnsetDetector.

Referenced by enumeratePlugins().

virtual ParameterList Vamp::PluginBase::getParameterDescriptors | ( |  | ) | const`[inline, virtual, inherited]`

Get the controllable parameters of this plugin.

Reimplemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, AmplitudeFollower, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 208 of file vamp-sdk/PluginBase.h.

Referenced by enumeratePlugins().

virtual float Vamp::PluginBase::getParameter | ( | std::string |  | ) | const`[inline, virtual, inherited]`

Get the value of a named parameter.

The argument is the identifier field from that parameter's descriptor.

Reimplemented in Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, AmplitudeFollower, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 216 of file vamp-sdk/PluginBase.h.

virtual void Vamp::PluginBase::setParameter | ( | std::string | ,
|  | float |
| ) |  | `[inline, virtual, inherited]`

Set a named parameter.

The first argument is the identifier field from that parameter's descriptor.

Reimplemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, AmplitudeFollower, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 222 of file vamp-sdk/PluginBase.h.

virtual ProgramList Vamp::PluginBase::getPrograms | ( |  | ) | const`[inline, virtual, inherited]`

Get the program settings available in this plugin.

A program is a named shorthand for a set of parameter values; changing the program may cause the plugin to alter the values of its published parameters (and/or non-public internal processing parameters). The host should re-read the plugin's parameter values after setting a new program.

The programs must have unique names.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 237 of file vamp-sdk/PluginBase.h.

virtual std::string Vamp::PluginBase::getCurrentProgram | ( |  | ) | const`[inline, virtual, inherited]`

Get the current program.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 242 of file vamp-sdk/PluginBase.h.

virtual void Vamp::PluginBase::selectProgram | ( | std::string |  | ) | `[inline, virtual, inherited]`

Select a program.

(If the given program name is not one of the available programs, do nothing.)

Reimplemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 248 of file vamp-sdk/PluginBase.h.

## Member Data Documentation

float Vamp::Plugin::m_inputSampleRate`[protected]`

Definition at line 436 of file vamp-sdk/Plugin.h.

Referenced by FixedTempoEstimator::D::assembleFeatures(), FixedTempoEstimator::D::calculate(), FixedTempoEstimator::D::getOutputDescriptors(), ZeroCrossing::getOutputDescriptors(), PercussionOnsetDetector::getOutputDescriptors(), AmplitudeFollower::initialise(), FixedTempoEstimator::D::initialise(), FixedTempoEstimator::D::lag2tempo(), SpectralCentroid::process(), ZeroCrossing::process(), PercussionOnsetDetector::process(), and FixedTempoEstimator::D::tempo2lag().

The documentation for this class was generated from the following file:

- vamp-sdk/Plugin.h